#pragma semicolon 1
#include <sourcemod>

/* Health max increase for each level */
#define HBONUS_INC 25

new Handle:g_hHealthPlusConfig;

Item_HealthPlus_PreInit()
{
	g_hHealthPlusConfig = RegisterItemType("Health+", "hbonus", 16, true, 16, 10, 10, HealthP_Buy, HealthP_Sell);
}

public bool:HealthP_Buy(client)
{
	if(!GetArrayCell(g_hHealthPlusConfig, ITEM_ENABLE))
		return false;
	
	new iHealth = GetClientHealth(client);
	if(iHealth >= (100 + HBONUS_INC * (GetPlayerItemLevel(client, GetArrayCell(g_hHealthPlusConfig, ITEM_INDEX))-1)))
		SetEntityHealth(client, HealthP_GetMaxHealth(client));
	
	return true;
}

public bool:HealthP_Sell(client)
{
	if(!GetArrayCell(g_hHealthPlusConfig, ITEM_ENABLE))
		return false;
	
	if(GetClientHealth(client) > HealthP_GetMaxHealth(client))
		SetEntityHealth(client, HealthP_GetMaxHealth(client));
	
	return true;
}

HealthP_SetSpawnHealth(client)
{
	if(!GetArrayCell(g_hHealthPlusConfig, ITEM_ENABLE))
		return;
	
	if(!GetConVarBool(g_hCVBotEnable) && IsFakeClient(client))
		return;
	
	SetEntityHealth(client, HealthP_GetMaxHealth(client));
}

stock HealthP_GetMaxHealth(client)
{
	if(!GetArrayCell(g_hHealthPlusConfig, ITEM_ENABLE))
		return 100;
	
	return 100 + HBONUS_INC * GetPlayerItemLevel(client, GetArrayCell(g_hHealthPlusConfig, ITEM_INDEX));
}