#pragma semicolon 1
#include <sourcemod>

new Handle:g_hRegenerationConfig;

new Handle:g_hIncreaseHealthTimer = INVALID_HANDLE;

Item_Regeneration_PreInit()
{
	g_hRegenerationConfig = RegisterItemType("Regeneration", "regen", 15, true, 5, 5, 10, Regeneration_Buy, Regeneration_Sell);
}

Regeneration_Init()
{
	//if(!GetArrayCell(g_hRegenerationConfig, ITEM_ENABLE))
	//	return;
	
	g_hIncreaseHealthTimer = CreateTimer(1.0, Regeneration_Timer_IncreaseHealth, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

Regeneration_Shutdown()
{
	ClearHandle(g_hIncreaseHealthTimer);
}

public bool:Regeneration_Buy(client)
{
	return true;
}

public bool:Regeneration_Sell(client)
{
	return true;
}

public Action:Regeneration_Timer_IncreaseHealth(Handle:timer, any:data)
{
	if(!GetConVarBool(g_hCVEnable) || !GetArrayCell(g_hRegenerationConfig, ITEM_ENABLE))
		return Plugin_Continue;
	
	new bool:bBotEnable = GetConVarBool(g_hCVBotEnable);
	
	decl iRegenerationLevel;
	for(new i=1;i<=MaxClients;i++)
	{
		if(!IsClientInGame(i))
			continue;
		
		if(!bBotEnable && IsFakeClient(i))
			continue;
		
		iRegenerationLevel = GetPlayerItemLevel(i, GetArrayCell(g_hRegenerationConfig, ITEM_INDEX));
		if(iRegenerationLevel <= 0)
			continue;
		
		if(GetClientHealth(i)+iRegenerationLevel > HealthP_GetMaxHealth(i))
			SetEntityHealth(i, HealthP_GetMaxHealth(i));
		else
			SetEntityHealth(i, GetClientHealth(i)+iRegenerationLevel);
	}
	
	return Plugin_Continue;
}