#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

new Handle:g_hResupplyConfig;

new Handle:g_hResupplyTimer = INVALID_HANDLE;

Item_Resupply_PreInit()
{
	g_hResupplyConfig = RegisterItemType("Resupply", "resup", 20, true, 5, 5, 15, Resupply_Buy, Resupply_Sell);
}

Resupply_Init()
{
	//if(!GetArrayCell(g_hResupplyConfig, ITEM_ENABLE))
	//	return;
	
	g_hResupplyTimer = CreateTimer(3.0, Resupply_Timer_Resupply, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

Resupply_Shutdown()
{
	ClearHandle(g_hResupplyTimer);
}

public bool:Resupply_Buy(client)
{
	return true;
}

public bool:Resupply_Sell(client)
{
	return true;
}

public Action:Resupply_Timer_Resupply(Handle:timer, any:data)
{
	if(!GetConVarBool(g_hCVEnable) || !GetArrayCell(g_hResupplyConfig, ITEM_ENABLE))
		return Plugin_Continue;
	
	new bool:bBotEnable = GetConVarBool(g_hCVBotEnable);
	
	decl iResupplyLevel;
	for(new i=1;i<=MaxClients;i++)
	{
		if(!IsClientInGame(i))
			continue;
		
		if(!bBotEnable && IsFakeClient(i))
			continue;
		
		iResupplyLevel = GetPlayerItemLevel(i, GetArrayCell(g_hResupplyConfig, ITEM_INDEX));
		if(iResupplyLevel <= 0)
			continue;

		new iType = 15;
		while(iType--)
		{
			if(iType != 12) /* 12 = flashbang */
			{
				// Fall back to non-limit alternative, if sdkcall fails.
				if(GiveAmmo(i, iResupplyLevel, iType, true) == -1)
					SetEntProp(i, Prop_Send, "m_iAmmo", GetEntProp(i, Prop_Send, "m_iAmmo", 4, iType)+iResupplyLevel, 4, iType);
			}
		}
	}
	
	return Plugin_Continue;
}