#pragma semicolon 1
#include <sourcemod>

/* Percent of damage to convert to attacker's health for each level */
#define VAMP_INC 0.075

new Handle:g_hVampireConfig;

Item_Vampire_PreInit()
{
	g_hVampireConfig = RegisterItemType("Vampire", "vamp", 15, true, 10, 15, 10, Vampire_Buy, Vampire_Sell);
}

public bool:Vampire_Buy(client)
{
	return true;
}

public bool:Vampire_Sell(client)
{
	return true;
}

Vampire_PlayerDamage(attacker, victim, dmg_health, dmg_armor)
{
	if(!GetConVarBool(g_hCVEnable) || !GetArrayCell(g_hVampireConfig, ITEM_ENABLE))
		return;
	
	IF_BOT_NENABLED(attacker)
		return;
	
	if(GetClientTeam(attacker) == GetClientTeam(victim))
		return;
	
	new iLevel = GetPlayerItemLevel(attacker, GetArrayCell(g_hVampireConfig, ITEM_INDEX));
	
	if(iLevel <= 0)
		return;
	
	new iTotalDmg = dmg_health + dmg_armor;
	new Float:fIncrease = float(iLevel) * VAMP_INC;
	fIncrease *= float(iTotalDmg);
	fIncrease += 0.5;
	
	new iNewHealth = GetClientHealth(attacker) + RoundToFloor(fIncrease);
	if(iNewHealth > HealthP_GetMaxHealth(attacker))
		iNewHealth = HealthP_GetMaxHealth(attacker);
	
	SetEntityHealth(attacker, iNewHealth);
}