#pragma semicolon 1
#include <sourcemod>
#include <sdktools>

/* Ignite duration increase for every level */
#define FNADE_INC 2
#define FNADE_DMG_MIN 5

new Handle:g_hFNadeConfig;

Item_FNade_PreInit()
{
	g_hFNadeConfig = RegisterItemType("FireGrenade", "fnade", 10, true, 5, 15, 10, FNade_Buy, FNade_Sell);
}

public bool:FNade_Buy(client)
{
	return true;
}

public bool:FNade_Sell(client)
{
	return true;
}

FNade_PlayerDamage(attacker, victim, dmg_health, dmg_armor)
{
	if(!GetConVarBool(g_hCVEnable) || !GetArrayCell(g_hFNadeConfig, ITEM_ENABLE))
		return;
	
	// Enough damage?
	if((dmg_health+dmg_armor) < FNADE_DMG_MIN)
		return;
	
	new iLevel = GetPlayerItemLevel(attacker, GetArrayCell(g_hFNadeConfig, ITEM_INDEX));
	
	if(iLevel <= 0)
		return;
	
	IF_BOT_NENABLED(attacker)
		return;
	
	if(GetClientTeam(attacker) == GetClientTeam(victim))
		return;
	
	new Float:fDuration = float(iLevel*FNADE_INC);
	IgniteEntity(victim, fDuration);
}